const express = require('express')
const router = express.Router()

const artigo_unknown = {titulo:"Desconhecido",conteudo:"Artigo não encontrado"}
// FAKE DATA
const artigos = {
1:{titulo:"Artigo 1",conteudo:"Conteúdo do primeiro artigo"},
2:{titulo:"Artigo 2",conteudo:"Conteúdo do segundo artigo"}
}

artigosIdCount = 3;

router.get("/", (req, res) => {    
    res.render("artigos", {artigos:artigos})
})

router.get("/new", (req, res) => {
    res.render("novoartigo")
})

router.post("/new", (req, res) => {
    const novoArtigo = {
        titulo: req.body.titulo,
        conteudo: req.body.conteudo
    };
    artigos[artigosIdCount++] = novoArtigo;

    res.redirect("/artigo/"+(artigosIdCount-1));
});

router.route("/:id")
.get((req,res) => {
    res.render("verartigo", {artigo:req.artigo})
})
.post((req,res) => {
    res.send("POST artigo "+JSON.stringify(req.artigo));
})
.delete((req,res) => {
    res.send("DELETE artigo "+JSON.stringify(req.artigo));
});

    // por último
router.param("id", (req,res,next,id) => {
    req.artigo = artigos[id]
    if(!req.artigo) req.artigo = artigo_unknown
    next()
})

// exportar o router para ser possível utilizá-lo no server.js
module.exports = router